{ Este exemplo demonstra como fazer uma figura geomtrica ficar
  passeando pela tela do micro. Isto pode ser usado como material
  didtico para iniciantes em programao. Pode tambm ser
  aprimorado para ser usado como proteo de tela.

  Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte
}

unit uBola;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    ParaDireita, ParaBaixo: boolean;
    P: TPoint;
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  Diametro = 200;
  Salto = 1;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Define a posio e os sentidos iniciais do movimento }
  P.x := 0;
  P.y := 0;
  ParaDireita := true;
  ParaBaixo := true;

  { Faz o formulrio cobrir toda tela, na cor preta.
    Isto faz este programa ficar semelhante a uma proteo de tela. }
  BorderStyle := bsNone;
  Left := 0;
  Top := 0;
  Width := Screen.Width;
  Height := Screen.Height;
  Color := clBlack;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  OldRg, NewRg, Rg: HRGN;
begin
  OldRg := 0;
  NewRg := 0;
  Rg := 0;

  try
    OldRg := CreateEllipticRgn(P.x, P.y, P.x + Diametro, P.y + Diametro);

    { Se estiver indo para direita... }
    if ParaDireita then begin
      { Se ainda pode dar mais um salto para direita
        sem sair do limite  direita do formulrio... }
      if P.x + Salto + Diametro <= ClientWidth then
        Inc(P.x, Salto)
      else begin
        { Se ainda no chegou ao limite mximo
           direita do formulrio... }
        if P.x + Diametro < ClientWidth then
          P.x := ClientWidth - Diametro
        else begin
          { Inverte o sentido horizontal.
            Agora vai andar para esquerda. }
          ParaDireita := false;
          Dec(P.x, Salto);
        end;
      end;
    end else begin { Est andando para esquerda. }
      { Se ainda pode dar mais um salto para esquerda
        sem sair do limite  esquerda do formulrio... }
      if P.x - Salto >= 0 then
        Dec(P.x, Salto)
      else begin
        { Se ainda no chegou ao limite mnimo  esquerda
          do formulrio... }
        if P.x > 0 then
          P.x := 0
        else begin
          { Muda o sentido horizontal.
            Agora vai andar para direita. }
          ParaDireita := true;
          Inc(P.x, Salto);
        end;
      end;
    end;

    { Se estiver descendo... }
    if ParaBaixo then begin
      { Se ainda pode dar mais um salto para baixo
        sem sair do limite inferior do formulrio... }
      if P.y + Salto + Diametro <= ClientHeight then
        Inc(P.y, Salto)
      else begin
        { Se ainda no chegou no limite mximo
          inferior do formulrio... }
        if P.y + Diametro < ClientHeight then
          P.y := ClientHeight - Diametro
        else begin
          { Muda o sentido vertical.
            Agora vai andar para cima. }
          ParaBaixo := false;
          Dec(P.y, Salto);
        end;
      end;
    end else begin { Est andando para cima. }
      { Se ainda pode dar mais um salto para cima
        sem sair do limite superior do formulrio... }
      if P.y - Salto >= 0 then
        Dec(P.y, Salto)
      else begin
        { Se ainda no atingiu o limite superior do formulrio... }
        if P.y > 0 then
          P.y := 0
        else begin
          { Muda o sentido vertical.
            Agora vai andar para baixo. }
          ParaBaixo := true;
          Inc(P.y, Salto);
        end;
      end;
    end;

    NewRg := CreateEllipticRgn(P.x, P.y, P.x + Diametro, P.y + Diametro);

    { Pinta com a cor do formulrio apenas a parte da regio velha
      que no faz parte da nova regio. Isto evita ter que desenhar
      toda o crculo novamente, o que causaria piscao. }

    Rg := OldRg;
    CombineRgn(Rg, OldRg, NewRg, RGN_DIFF);
    Canvas.Brush.Color := Color;
    PaintRgn(Canvas.Handle, Rg);

    { Pinta apenas a parte da nova regio que no est contida
      na regio velha. }
    Rg := NewRg;
    CombineRgn(Rg, NewRg, OldRg, RGN_DIFF);
    Canvas.Brush.Color := clWhite;
    PaintRgn(Canvas.Handle, Rg);
  finally
    DeleteObject(OldRg);
    DeleteObject(NewRg);
    DeleteObject(Rg);
  end;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  { Se der um click, fecha. }
  Close;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  { Se pressionar qualquer tecla, fecha. }
  Close;
end;

end.
